<script lang="ts">
  import { numberWithCommas } from "src/functions/comma-number";
  import type { CartProductModel } from "src/models/cart.product.type";
  import { Page } from "src/page";
  import {
    pageSelectedStore,
    cartOrdersStore,
    billOrderStore,
    userProfileStore,
  } from "src/store";

  const billId = `BILLNO_${Date.now()}`;
  let checkBoxAllOrder: boolean = true;

  function addCount(index: number) {
    $cartOrdersStore[index].amount++;
    $cartOrdersStore[index].sumPrice =
      $cartOrdersStore[index].amount *
      ($cartOrdersStore[index].price -
        ($cartOrdersStore[index].price * $cartOrdersStore[index].discount) /
          100);
  }

  function minusCount(index: number) {
    $cartOrdersStore[index].amount > 1
      ? $cartOrdersStore[index].amount--
      : ($cartOrdersStore[index].amount = 1);
    $cartOrdersStore[index].sumPrice =
      $cartOrdersStore[index].amount *
      ($cartOrdersStore[index].price -
        ($cartOrdersStore[index].price * $cartOrdersStore[index].discount) /
          100);
  }

  function deleteItemCart(id: string) {
    $cartOrdersStore = $cartOrdersStore.filter((cart) => cart.id != id);
    if ($cartOrdersStore.length <= 0) {
      $cartOrdersStore = [];
    }
  }

  function calcSumPriceBill(cartOrders: CartProductModel[]): number {
    let sumprice = 0;
    (cartOrders || []).forEach((cartItem) => {
      if (cartItem.selected) {
        sumprice += cartItem.sumPrice || 0;
      }
    });
    return sumprice;
  }

  $: {
    $billOrderStore = {
      billId: billId,
      userId: $userProfileStore.userId,
      productList:
        $cartOrdersStore && $cartOrdersStore.length
          ? $cartOrdersStore.filter(
              (cartProd: CartProductModel) => cartProd.selected
            )
          : [],
      sumPriceBill: calcSumPriceBill($cartOrdersStore),
      statusOrder: "สร้างรายการ",
    };

    if (
      $cartOrdersStore &&
      $cartOrdersStore.find((cart) => cart.selected == false)
    ) {
      checkBoxAllOrder = false;
    }
  }

  function onCheckBoxAll() {
    if (!checkBoxAllOrder) {
      ($cartOrdersStore || []).forEach((cart) => {
        cart.selected = true;
      });
      $cartOrdersStore = $cartOrdersStore;
    } else {
      ($cartOrdersStore || []).forEach((cart) => {
        cart.selected = false;
      });
      $cartOrdersStore = $cartOrdersStore;
    }
  }

  function onCheckBoxChange() {
    setTimeout(() => {
      $cartOrdersStore = $cartOrdersStore;
    }, 100);
  }
</script>

{#if $cartOrdersStore && $cartOrdersStore.length > 0}
  <div class="mx-auto w-2/3 h-full flex flex-col">
    <div
      role="main"
      class="flex flex-col pt-5 mb-0 leading-4 text-gray-800"
      style="margin-bottom: 0px;"
    >
      <div
        class="flex overflow-hidden justify-items-center items-center py-0 px-5 mb-3 h-12 text-sm text-gray-600 capitalize bg-white rounded-sm shadow-xs"
      >
        <div
          class="flex flex-row-reverse py-0 pr-3 pl-5 capitalize box-border"
          style="min-width: 58px;"
        >
          <label class="inline-flex items-center p-2">
            <input
              on:click={onCheckBoxAll}
              bind:checked={checkBoxAllOrder}
              type="checkbox"
              class="form-checkbox h-5 w-5 text-green-600"
            /><span class="ml-2 text-gray-700" />
          </label>
        </div>
        <div class="text-gray-800 capitalize w-2/6">สินค้า</div>
        <div class="text-gray-800 capitalize text-center w-1/6">ตัวเลือก</div>
        <div class="text-center capitalize w-1/6">ราคาต่อชิ้น</div>
        <div class="text-center capitalize w-1/6">จำนวน</div>
        <div class="text-right capitalize w-1/6">ราคารวม</div>
        <div class="text-center capitalize w-1/6">แอคชั่น</div>
      </div>
      <div class="text-gray-800">
        {#each $cartOrdersStore || [] as cart, index}
          <div class="overflow-visible mb-4 bg-white rounded-sm shadow-xs">
            <div class="relative pb-px">
              <div class="block px-5 pt-4 pb-5 mt-4 no-underline">
                <div class="flex items-center">
                  <div class="flex flex-row-reverse py-0 pr-3 pl-5 box-border">
                    <label class="inline-flex items-center mt-3">
                      <input
                        type="checkbox"
                        class="form-checkbox h-5 w-5 text-green-600"
                        bind:checked={cart.selected}
                        on:click={onCheckBoxChange}
                      /><span class="ml-2 text-gray-700" />
                    </label>
                  </div>
                  <div class="flex relative flex-col box-border w-2/6">
                    <div class="flex">
                      <img alt="cart_img"
                        src={cart.image}
                        class="w-20 h-20 bg-no-repeat bg-contain"
                      />
                      <div
                        class="flex overflow-hidden flex-col pt-1 pr-5 pb-0 pl-2 w-64 text-sm"
                      >
                        <p
                          class="overflow-hidden mb-1 no-underline bg-transparent cursor-pointer text-lg font-bold"
                        >
                          {cart.productName} <br />
                        </p>
                        <p
                          class="overflow-hidden mb-1 no-underline bg-transparent cursor-pointer text-gray-400"
                        >
                          {cart.desc}
                        </p>
                        <div class="flex text-red-600" />
                      </div>
                    </div>
                  </div>
                  <div class="flex justify-center items-center w-1/6">
                    {cart.optionSelect.productName}
                  </div>
                  <div class="flex flex-col justify-center items-center w-1/6">
                    <div class="">
                      <span class="m-0"
                        >{numberWithCommas(
                          cart.price - (cart.price * cart.discount) / 100
                        )}</span
                      >
                    </div>
                  </div>
                  <div class="flex flex-col justify-center items-center  w-1/6">
                    <div class="flex items-center">
                      <button
                        on:click={() => minusCount(index)}
                        class="flex overflow-visible justify-center items-center m-0 w-8 h-8 text-sm font-light tracking-normal leading-none text-center normal-case bg-transparent rounded-sm border border-gray-300 border-solid cursor-pointer"
                        style="outline: none; transition: background-color 0.1s cubic-bezier(0.4, 0, 0.6, 1) 0s; border-top-right-radius: 0px; border-bottom-right-radius: 0px;"
                      >
                        <svg
                          enable-background="new 0 0 10 10"
                          viewBox="0 0 10 10"
                          x="0"
                          y="0"
                          class="inline-block relative w-2 h-2"
                          style="fill: currentcolor; font-size: 10px; line-height: 10px;"
                        >
                          <polygon
                            points="4.5 4.5 3.5 4.5 0 4.5 0 5.5 3.5 5.5 4.5 5.5 10 5.5 10 4.5"
                            class=""
                            style="font-size: 10px; line-height: 10px;"
                          />
                        </svg></button
                      ><input
                        class="flex justify-center items-center m-0 w-12 h-8 text-base font-normal tracking-normal leading-none text-center bg-transparent rounded-none border-t border-b border-gray-300 border-solid appearance-none cursor-text box-border"
                        type="text"
                        on:change={() =>
                          ($cartOrdersStore[index].sumPrice =
                            $cartOrdersStore[index].amount *
                            $cartOrdersStore[index].price)}
                        bind:value={cart.amount}
                        style="outline: none; transition: background-color 0.1s cubic-bezier(0.4, 0, 0.6, 1) 0s; border-width: 1px;"
                      /><button
                        on:click={() => addCount(index)}
                        class="flex overflow-visible justify-center items-center m-0 w-8 h-8 text-sm font-light tracking-normal leading-none text-center normal-case bg-transparent rounded-sm border border-gray-300 border-solid cursor-pointer"
                        style="outline: none; transition: background-color 0.1s cubic-bezier(0.4, 0, 0.6, 1) 0s; border-top-left-radius: 0px; border-bottom-left-radius: 0px;"
                      >
                        <svg
                          enable-background="new 0 0 10 10"
                          viewBox="0 0 10 10"
                          x="0"
                          y="0"
                          class="inline-block relative w-2 h-2"
                          style="fill: currentcolor; font-size: 10px; line-height: 10px;"
                        >
                          <polygon
                            points="10 4.5 5.5 4.5 5.5 0 4.5 0 4.5 4.5 0 4.5 0 5.5 4.5 5.5 4.5 10 5.5 10 5.5 5.5 10 5.5"
                            class=""
                            style="font-size: 10px; line-height: 10px;"
                          />
                        </svg>
                      </button>
                    </div>
                  </div>
                  <div class="text-right text-red-600 w-1/6">
                    <span class="">{numberWithCommas(cart.sumPrice)}</span>
                  </div>
                  <div
                    class="flex flex-col justify-center items-center capitalize w-1/6"
                  >
                    <button
                      on:click={() => deleteItemCart(cart.id)}
                      class="overflow-visible m-0 text-center normal-case bg-none cursor-pointer hover:text-red-600"
                    >
                      ลบ
                    </button>
                  </div>
                </div>
              </div>
            </div>
          </div>
        {/each}
      </div>

      <div class="bg-white">
        <div
          class="flex flex-1 items-center py-3 px-0 w-full text-base leading-5 text-gray-800"
          style="grid-column: 1 / 4;"
        >
          <div class="flex-1 leading-5" />
          <div class="flex flex-col leading-5">
            <div class="flex justify-end items-center text-gray-800">
              <div class="flex items-center ml-5">
                <p class="px-5">รวมราคาทั้งสิ้น</p>
                <div class="ml-1 text-3xl leading-7 text-red-600">
                  ฿{numberWithCommas($billOrderStore.sumPriceBill || 0)}
                </div>
              </div>
            </div>
          </div>
          <div class="leading-5">
            <button
              on:click={() => ($pageSelectedStore = Page.PAYMENT)}
              disabled={$billOrderStore.sumPriceBill <= 0}
              class:bg-gray-400={$billOrderStore.sumPriceBill <= 0}
              class:bg-red-600={$billOrderStore.sumPriceBill > 0}
              class="flex overflow-visible relative justify-center items-center py-3 px-8 my-0 mr-5 ml-4 w-56 h-10 text-sm font-light tracking-normal leading-none text-center text-white capitalize rounded-sm cursor-pointer select-none box-border shadow-xs focus:shadow-xs"
              style="outline: none; transition: opacity 0.2s ease 0s;"
            >
              <span class="w-full leading-3 capitalize">สั่งสินค้า</span>
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
{:else}
  <div
    class="flex flex-col justify-center items-center leading-4 text-gray-800"
    style="height: 336px;"
  >
    <img
      alt="cart-empty"
      src="./imgs/cart-empty.png"
      class="w-24 h-24 text-gray-800 bg-no-repeat bg-cover"
    />
    <div class="mt-4 text-sm font-bold text-gray-500">
      ตะกร้าของเธอว่างอยู่นะ
    </div>
    <a
      class="block mt-4 text-gray-800 no-underline bg-transparent cursor-pointer"
      href="/"
      ><button
        on:click={() => ($pageSelectedStore = Page["MAIN"])}
        class="flex overflow-visible relative justify-center items-center py-2 px-10 m-0 text-sm font-light tracking-normal leading-none text-center text-white normal-case bg-red-600 rounded-sm select-none shadow-xs hover:bg-red-600 focus:bg-red-600 focus:shadow-xs"
        style="outline: none; transition: opacity 0.2s ease 0s;"
      >
        <span class="text-base capitalize">ช้อปปิ้งกันเลย</span>
      </button></a
    >
  </div>
{/if}
